"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenLoader = void 0;
var passport_jwt_1 = require("passport-jwt");
var TokenLoader_1 = __importDefault(require("./TokenLoader"));
exports.TokenLoader = TokenLoader_1.default;
var FirebaseStrategy = /** @class */ (function (_super) {
    __extends(FirebaseStrategy, _super);
    function FirebaseStrategy(options, verify) {
        if (options === void 0) { options = {
            jwtFromRequest: passport_jwt_1.ExtractJwt.fromAuthHeaderAsBearerToken(),
        }; }
        if (verify === void 0) { verify = FirebaseStrategy.DefaultVerfierCallBack; }
        return _super.call(this, __assign(__assign({}, options), { secretOrKeyProvider: FirebaseStrategy.FirebaseSecretOrKeyProvider }), verify) || this;
    }
    FirebaseStrategy.FirebaseSecretOrKeyProvider = function (_, rawJwtToken, done) {
        try {
            var header64 = rawJwtToken.split(".")[0];
            var header = JSON.parse(Buffer.from(header64, "base64").toString("ascii"));
            var secret = TokenLoader_1.default.Get(String(header.kid));
            return done(null, secret);
        }
        catch (err) {
            return done(err, null);
        }
    };
    FirebaseStrategy.DefaultVerfierCallBack = function (user, done) {
        return done(null, user);
    };
    return FirebaseStrategy;
}(passport_jwt_1.Strategy));
exports.default = FirebaseStrategy;
